#version 130

// Input vertex data, different for all executions of this shader.
in vec3 vertexPosition_modelspace;
in vec3 vertexNormal;


// Values that stay constant for the whole mesh.
uniform mat4 ModelViewProjection;
uniform mat4 Model;
uniform mat3 NormalMatrix;

out vec3 FragPos;
out vec3 Normal;

void main(){

	// Output position of the vertex, in clip space : MVP * position
	gl_Position = ModelViewProjection * vec4(vertexPosition_modelspace,1);

    FragPos = vec3(Model * vec4(vertexPosition_modelspace,1));

    Normal = normalize(NormalMatrix * vertexNormal);
    //Normal = normalize(mat3(transpose(inverse(Model))) * vertexNormal);  

}